//Copyright 2009 Chris Glasier

/* 
Release 1.0 - Basic configuration
Release 1.01 - Revisions
	
# 	Added sketchup.rb (thanks to Tomasz SCF)
#	Add new scene setup for new files
>>	Right aligned menu
# 	Rename layer
#	Excluded Layer0

cgScenes is designed to reduce the number of SU windows that need to be open. For example, if the SU layers window is open, you will see any amendments made in cgScenes instantly changed in SU layers - that is you don't need to have layers window open. 

cgScenes is an alternative, not a replacement. How much functionality is provided in cgScenes is determined by its usefulness. Changes made directly in SU are mirrored in cgScenes by clicking "Refresh" (this may be automated later)

It is simple to right click a scene tab to delete or rename it; on the otherhand, to rename a layer the layer window needs to be open; it is simpler to have layer renaming in cgScenes as well.  Hardly an expert but I have found the most useful cgScenes functions for modelmaking are showing and hiding layers and components, and alternating scenes, views and styles. I suspect it is much the same for those who just want to better understand the model and what is required for the real thing.



	
*/

/*

A device using nameset interface technology to create/edit/review Sketchup scenes
Follows standard nameset for later integration
*/

panelWidth = 230
panelHeight = 345
cellHeight = 20
columns 	= 3

midRowTop = 5
stripeCells = 1


aspectArray = new Array()
aspectArray.push(new Array("Properties","Property","true"))
aspectArray.push(new Array("Layers","Layer","true"))
aspectArray.push(new Array("Components","Component","true"))
//aspectArray.push(new Array("Collections","Collection","true"))
//aspectArray.push(new Array("Groupings","Grouping","true"))
aspectArray.push(new Array("Views","View","true"))
aspectArray.push(new Array("Styles","Style","true"))

viewsArray = new Array()
viewsArray.push(new Array("View","Top","true"))
viewsArray.push(new Array("View","Bottom","true"))
viewsArray.push(new Array("View","Front","true"))
viewsArray.push(new Array("View","Back","true"))
viewsArray.push(new Array("View","Left","true"))
viewsArray.push(new Array("View","Right","true"))
viewsArray.push(new Array("View","Isometric","true"))
viewsArray.push(new Array("View","ZoomExtents","true"))
viewsArray.push(new Array("View","Perspective","true"))

newScenes = new Array("3d","Ortho","Trade")


function start(){

window.location = "skp:sceneCount"  

if(count == 0 ){
list = newScenes
for(a=0; a<list.length; a++){

window.location = "skp:sceneScenesAdd@"+list[a]  }   }

sceneSet()
sceneFirst()
sceneRun()   }


function receiveSceneCount(x){
count = x    }

function sceneResize(){
panelWidth = document.body.clientWidth
panelHeight = document.body.clientHeight
cellWidth = Math.floor(panelWidth/columns)
rows = Math.floor(panelHeight/cellHeight)
sceneRun() 
eval("sceneRun"+sceneAspect)()
document.getElementById("stripe").style.width = stripeCells * cellWidth      }


function sceneSet(){

dialogSize()

scenePanelNames()

layerSort = "abc"
//componentSort = "show"  all show /hide not yet done

confirmPanel.style.display = "none"

sliderTops = new Array(0,0,0)

sceneAspect = "Properties"
sliderTops[1] = 0

theMenu = "Refresh"
setMenu()

menuList = sceneScenesList

commander = "Scenes"  }



function receiveFirstScene(x){
ind = x    }


function sceneFirst(){

window.location = "skp:firstScene"

//ind from receiveScenes

sliderTops[0] = ind

params = new Array(ind)
params = params.join(",")
window.location = "skp:selectedScene@"+params

   }


function sceneRun(){

devicePanel.innerHTML = ""

sceneSetDeviceHolder()
sceneStripe()
sceneColumnSliders()
scenePanelSizes()

sceneRunScenes()
sceneAdjustSlider()

sceneMenu2List()

sceneRunAspects()    }


function dialogSize(){

w = panelWidth+6
h = panelHeight+30

cellWidth = Math.floor(panelWidth/columns)
rows = Math.floor(panelHeight/cellHeight)

params = new Array(w,h)

params = params.join(",")
window.location = "skp:set_size@"+ params   }


function scenePanelNames(){
copyPanel = document.getElementById("copy")
namePanel = document.getElementById("name")
devicePanel = document.getElementById("device")
confirmPanel = document.getElementById("confirm")
menuPanel1 = document.getElementById("menu1")
menuPanel2 = document.getElementById("menu2")   }


function sceneSetDeviceHolder(){
obj = document.createElement("div")
devicePanel.appendChild(obj)
obj.id = "holder"
deviceHolder = document.getElementById("holder")
with(deviceHolder){
with(style){
top = 0
width = panelWidth
height = panelHeight   }  }  }


function sceneStripe(){
obj = document.createElement("div")
deviceHolder.appendChild(obj)
with(obj){
id  = "stripe"
with(style){
left = 0
top = midRowTop * cellHeight
width = stripeCells * cellWidth
height = cellHeight 
backgroundColor = "#ffffff"  } }  }


function sceneColumnSliders(){
bLeft = 0
for(a=0; a<columns; a++){
sceneColumnSlider() }  } 


function sceneColumnSlider(){
obj = document.createElement("div")
deviceHolder.appendChild(obj)
with(obj){
colNo = a
id  = "sc"+ colNo   }   }



function scenePanelSizes(){
with(namePanel){
with(style){
left 	= 0
top 	= 2 * cellHeight  } }

with(devicePanel){
with(style){
left = 0
top = 2 * cellHeight}}

with(confirmPanel){
innerHTML = "UPDATE"
with(style){
left = panelWidth-cellWidth
top = 0   
width = cellWidth  }}


with(menuPanel1){
with(style){
left = 0
top = 0 
width = panelWidth
height = cellHeight
backgroundColor="#cccccc"   }  }

with(menuPanel2){
with(style){
left = 0
top = cellHeight
width = panelWidth
height = cellHeight
backgroundColor="#cccccc"
textAlign = "right"   }  } 

with(copyPanel){
innerHTML = "&copy;Chris Glasier 2008/9"
with(style){
left = 0
top = 0
width = panelWidth
color = "#bbbbbb"
textAlign= "right"  }  } 

//Sliders

bLeft = 0
for(a=0; a<columns; a++){
with(document.getElementById("sc"+a).style){
left = bLeft
width = bLeft * cellWidth   }
bLeft = bLeft += cellWidth    }   }



function receiveScenes(x){
scenesString = x    }

function sceneRunScenes(){

window.location = "skp:findScenes"
//from receiveScenes
list = scenesString.split(";")
sceneArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")

thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Scenes"
entry[1] = thisName
entry[2] = "true"

sceneArray.push(entry)  } 

childNos = sceneArray
colNo = 0
sceneRunChildren()  }


function sceneRunAspects(){
childNos = aspectArray
colNo = 1
sceneRunChildren()  }


function receiveProperties(x){
propertiesString = x    }

function sceneRunProperties(){
window.location = "skp:findProperties"

// from receiveLayers
list = propertiesString.split(";")

propertiesArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Property"
entry[1] = thisName
entry[2] = couplet[1]

propertiesArray.push(entry)  } 

childNos = propertiesArray
colNo = 2
sceneRunChildren() }


function receiveLayers(x){
layersString = x    }


function sceneRunLayers(){

window.location = "skp:findLayers"

// from receiveLayers
list = layersString.split(";")
list.sort()

if(layerSort == "vis"){
visArray = new Array()
invArray = new Array()

for(a=0; a<list.length; a++){
list[a]=list[a].split(",")

if(list[a][1] == "true") visArray.push(list[a].join(","))
else invArray.push(list[a].join(","))}
list = visArray.concat(invArray)   }

layersArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

if(thisName == "Layer0") continue

entry = new Array()
entry[0] = "Layer"
entry[1] = thisName
entry[2] = couplet[1]
entry[3] = couplet[2]

layersArray.push(entry)  } 

//firstEntry = new Array("Layer","Layer0","true")
//layersArray.splice(0,0,firstEntry)

childNos = layersArray
colNo = 2
sceneRunChildren()  }

function receiveComponents(x){
componentsString = x    }


function sceneRunComponents(){

window.location = "skp:findComponents"

// from receiveComponents
list = componentsString.split(";")
list.sort()

componentsArray = new Array()

for(a=0; a<list.length; a++){

couplet = list[a].split(",")
thisName = couplet[0].split(" ")
thisName = thisName.join("_")

//if(componentSort == "show") couplet[1] = "false" //all show
//if(componentSort == "hide") couplet[1] = "true"  // all hide

entry = new Array()
entry[0] = "Component"
entry[1] = thisName
couplet[1]=="false"? entry[2] = "true" : entry[2] = "false"
entry[3] = couplet[2]

componentsArray.push(entry)  } 

childNos = componentsArray
colNo = 2
sceneRunChildren()   }


function receiveStyles(x){
stylesString = x    }

function receiveSceneStyle(y){
sceneStyle = y     }


function sceneRunStyles(){

window.location = "skp:sceneStyle"
stylesArray = new Array()

for(a=0; a<list.length; a++){


window.location = "skp:findStyles"

// from receiveLayers
list = stylesString.split(";")
list.sort()

couplet = list[a].split(",")

if(couplet[0] == sceneStyle) activeRow = a
sliderTops[2] = activeRow

thisName = couplet[0].split(" ")
thisName = thisName.join("_")

entry = new Array()
entry[0] = "Style"
entry[1] = thisName
entry[2] ="true"
entry[3] = couplet[1]
stylesArray.push(entry)  } 

childNos = stylesArray
colNo = 2
sceneRunChildren()
stripeCells = 3
document.getElementById("stripe").style.width = stripeCells * cellWidth   }


function sceneRunViews(){
childNos = viewsArray
colNo = 2
sceneRunChildren()  }


function sceneRunShadows(){
childNos = shadowsArray
colNo = 2
sceneRunChildren()  }

//RUN OFF

function sceneRunChildren(){
document.getElementById("sc"+ colNo).innerHTML = ""
bTop = 0
for(c=0; c<childNos.length; c++){

genericName = childNos[c][0]
givenName = childNos[c][1]
childNos[c][2] == "false"? theClass = "off" : theClass = "on"
childNos[c][3] == undefined? cind = 0 : cind = childNos[c][3]
obj = document.createElement("div")
document.getElementById("sc"+ colNo).appendChild(obj)

with(obj){
id = new Array(genericName,colNo,c,cind)
innerHTML = givenName
title = id			//for testing
className = theClass 
with(style){
left = 0
top = bTop 
width = cellWidth
height = cellHeight   }   }
bTop+= cellHeight    }   }


function sceneAdjustSlider(){
for(a=0; a<columns; a++){
cTop = sliderTops[a]-midRowTop
with(document.getElementById("sc"+ a).style){
top = -cTop*cellHeight   }  }  }


function sceneMenu2List(){
menuPanel2.innerHTML = ""
list = menuList.split(",")
for(a=0; a<list.length; a++){
obj = document.createElement("a")
menuPanel2.appendChild(obj)
with(obj){
innerHTML = list[a]
//a == 0? cl = "menu2" : cl = "menu1"
className = "menu2"   }  }  }

//EVENTS

function deviceDown(e){

// moves activeCell over stripe

thisCell = event.srcElement

if(thisCell.id == "holder") return

sceneCellId = thisCell.id.split(",")
genericName = sceneCellId[0]
commander = genericName

colNo = sceneCellId[1]
activeRow = sceneCellId[2]
cind = sceneCellId[3]

menuList = eval("scene"+commander+"List")
sceneMenu2List()


document.getElementById("stripe").style.width = stripeCells * cellWidth

try{ 
eval("scene"+colNo+"Down")() }
catch(e){    }  
sceneAdjustSlider()    }


function scene0Down(){
sliderTops[0] = activeRow
params = activeRow
window.location = "skp:selectedScene@"+params

stripeCells = 1
document.getElementById("stripe").style.width = stripeCells * cellWidth

try{ eval("sceneRun"+sceneAspect)()    }
catch(e){ document.getElementById("sc2").innerHTML = " "    }  }


function scene1Down(){
document.getElementById("sc2").innerHTML = ""
stripeCells = 2
document.getElementById("stripe").style.width = stripeCells * cellWidth
document.getElementById("sc2").style.top = 0
sliderTops[1]= activeRow
sliderTops[2]= 0
sceneAspect = genericName

try{ eval("sceneRun"+genericName)()    }
catch(e){ document.getElementById("sc2").innerHTML = ""  }}

function scene2Down(){
sliderTops[2]= activeRow
stripeCells = 3
document.getElementById("stripe").style.width = stripeCells * cellWidth
try{ eval("sceneTools"+genericName)()    }
catch(e){  }   }


function sceneToolsView(){
word = thisCell.innerHTML
window.location = "skp:view"+word 
sceneUpdater()   }

function sceneToolsComponent(){
window.location = "skp:hiliteClear"
window.location = "skp:hiliteOn@"+cind  }

function sceneToolsStyle(){
window.location = "skp:useStyle@"+cind
sceneUpdater()  }


//MENUS AND UPDATER

function setMenu(){
list = theMenu.split(",")
for(a=0; a<list.length;a++){
obj = document.createElement("a")
menuPanel1.appendChild(obj)
with(obj){
innerHTML = list[a]
className = "menu2" }    }    }

function menu1Down(e){
menuCell = event.srcElement
if(menuCell.id == "menu1") return
menuPanel2.innerHTML = ""
devicePanel.innerHTML = ""
menuName =  menuCell.innerHTML.split(" ").join("")
menuPanel = menuPanel1
//menuToggle()
try{
eval("sceneMenu1"+menuName)()   }
catch(e){}   }


function sceneMenu1Refresh(){
sceneFirst()
sceneRun() 
eval("sceneRun"+sceneAspect)()
document.getElementById("stripe").style.width = stripeCells * cellWidth      }


function menu2Down(e){

menuCell = event.srcElement
menuName =  menuCell.innerHTML.split(" ").join("")
menuPanel = menuPanel2
//menuToggle()
try{eval("scene"+commander+menuName)()   }
catch(e){  }  }


function menuToggle(){
coll = menuPanel.childNodes
for(a=0; a<coll.length; a++){
coll[a] == menuCell? cl = "menu2" : cl = "menu1" 
coll[a].className = cl  }   }

sceneScenesList = "Add"
scenePropertiesList = "List of properties to save"
sceneLayersList = "Abc,Visibility,Add"
//sceneComponentsList = "Show_all,Hide_all"
sceneComponentsList = "Collections and groupings in future release"
sceneCollectionsList = "To collect components retaining xyz's and rotations" 
sceneGroupingsList = "To collect components for logistical movement"
sceneViewsList = ""
sceneStylesList = "In model"
scenePropertyList = "Toggle"
sceneLayerList = "Rename,Toggle"
sceneComponentList = "Toggle"
sceneStyleList = ""
sceneViewList = ""


function sceneScenesAdd(){

window.location = "skp:sceneCount"

params ="Scene "+count

window.location = "skp:sceneScenesAdd@" + params
sceneMenu1Refresh()   }

/*

Use SU context menu

function sceneScenesErase(){
window.location = "skp:sceneScenesErase"

activeRow-=1
scene0Down()
sceneMenu1Refresh()   }
*/

function sceneLayersAbc(){
layerSort = "abc"
sceneMenu1Refresh() }

function sceneLayersVisibility(){
layerSort = "vis"
sceneMenu1Refresh() }

function sceneLayersAdd(){
window.location = "skp:sceneLayersAdd" 
sceneMenu1Refresh()   }

function sceneComponentsShow_all(){
componentSort = "show"
sceneMenu1Refresh() }

function sceneComponentsHide_all(){
componentSort = "hide"
sceneMenu1Refresh() }

function scenePropertyToggle(){
fileName = "scenePropertyToggle"+thisCell.innerHTML+thisCell.className
window.location = "skp:"+fileName
thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl
sceneUpdater() }


function sceneLayerRename(){
with(thisCell){
contentEditable = true
with(style){
cursor = "text"
border = "1px black solid"   }   }
sceneUpdater()          }


function sceneLayerToggle(){
fileName = "sceneLayerToggle"+thisCell.className
window.location = "skp:"+fileName+"@"+cind
thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl
sceneUpdater() }


function sceneLayerAdd(){
sceneLayersAdd()    }


function sceneLayerErase(){
window.location = "skp:sceneLayerErase@"+cind
sceneMenu1Refresh()   }


function sceneComponentToggle(){
fileName = "sceneComponentToggle"+thisCell.className
window.location = "skp:"+fileName+"@"+cind
thisCell.className == "on"? cl = "off" : cl = "on"
thisCell.className = cl
sceneUpdater()	 }


function sceneUpdater(){
confirmPanel.style.display ="block" 	}

//Updater is in confirm block

function confirmDown(e){

confirmPanel.style.display ="none"
window.location = "skp:sceneUpdate" 

coll = document.getElementById("sc2").childNodes
for(a=0; a<coll.length; a++){

if(coll(a).contentEditable == "true"){
coll(a).contentEditable = false
coll(a).style.borderWidth = 0
coll(a).style.cursor = "pointer"

newName = coll(a).innerHTML

ind = coll(a).id.split(",")
ind = ind[3]

params = new Array(ind,newName)
params = params.join(",")

window.location = "skp:sceneLayerRename@"+params
sceneMenu1Refresh()   }}}